var express = require('express');
var socketio = require('socket.io');
var twitter = require('ntwitter');
var util = require('util');
var fs = require('fs');
var path = require('path');
var _ = require('underscore');
var credentials = require('./credentials.js');

var app = express.createServer();
app.use(express.bodyParser());
app.use(express.errorHandler());
app.use(express.static(__dirname + '/web'));

app.get('/', function(req, res) {
    res.sendfile(__dirname + '/web/index.html')
});

app.listen(3000);
var io = socketio.listen(app);

console.log('Listening on');


var t = new twitter({
    consumer_key: credentials.consumer_key,
    consumer_secret: credentials.consumer_secret,
    access_token_key: credentials.access_token_key,
    access_token_secret: credentials.access_token_secret
});

var mongo = require('mongodb');
 
var Server = mongo.Server,
    Db = mongo.Db,
   assert = require('assert')
    BSON = mongo.BSONPure;
 
var server = new Server('localhost', 27017, {native_parser: true});
db = new Db('twitter', server);

var mongoose = require('mongoose'),
    bd = mongoose.connect('mongodb://localhost/twitter'),
    Schema = mongoose.Schema;
 
var Tweet = new Schema({
  tweet: String
});
var tweetModel = mongoose.model('tweets', Tweet);
 
var tweet = new tweetModel();

io.sockets.on('connection', function(socket) {
    socket.on('filter', function(text) {
   //socket.on('filter', function() {
        console.log('open stream on ', text);

	
	// open db
	//db.open(function(err, db) {
  	//assert.equal(null, err);

        t.stream('statuses/filter', {
		track: text, language: 'fr'
        }, function(s) {
            s.on('data', function(data) {
                console.log('received tweet ', data);



            	/*db.collection('tweets', function(err, collection) {
               collection.insert({'tweet': data.text}, {safe:true}
                                 , function(err, result) {});
            });*/

                socket.emit('tweet', data);
            });
		

            s.on('error', function(error) {
                console.log(util.inspect(error));
            });
            s.on('end', function() {
                console.log('****** ERROR: Twitter stream terminated!')
            });
        });
    });
//});
    socket.on('disconnect', function() {
        console.log('socket closed');
    });
});
